C CACHEHDR.FOR

	Subroutine CacheHdr (G, Article, Subject, Subject_Lg)

	Include 'News.Def'

C Parameter definition

	Integer   *4	G
	Integer   *4 	Article
	Character *(*)	Subject
	Integer   *4    Subject_Lg

C External routines

	Integer		TrimLg

C Local definitions

	Integer   *4	NCache
	Character *128	Cache_Subject (500)
	Integer   *4    Cache_Article (500)
	Integer   *4	I

C 	Begin CacheHdr

C Is the requested information in the cache?

	If (NCache .gt. 0) Then
	  Do I = 1, NCache
	    If (Cache_Article(I) .eq. Article) Then
	      Subject = Cache_Subject(I)
	      Subject_Lg = TrimLg(Subject)
	      Return
	    EndIf
	  EndDo
	EndIf

C Requested information not cached, we have to read it.

	Call XHdr (Article, 'subject', Subject, Subject_Lg)
	If (NCache .lt. 500) Then
	  NCache = NCache + 1
	  I = NCache
	Else
	  I = 1
	EndIf

	Cache_Subject(I) = Subject(1:Subject_Lg)
	Cache_Article(I) = Article
	

	Return

C	Begin CacheHdr_Init

	Entry CacheHdr_Init (G)

	NCache = 0

	Return

	END
